require_relative "datahub-http-client"
require_relative "datahub-project"
require_relative "datahub-topic"

class DatahubClient

    def initialize(endpoint, access_id, access_key)
        @endpoint = endpoint
        @access_id = access_id
        @access_key = access_key
        
        @http_client = DatahubHttpClient.new(@endpoint, @access_id, @access_key)
    end

    def create_project(project_name, comment)
        @http_client.create_project(project_name, comment)
    end
    
    def delete_project(project_name)
        @http_client.delete_project(project_name)
    end
    
    def get_project(project_name)
        return DatahubProject.new(@http_client, project_name)        
    end

end