
class RecordEntity
    $STRING_MAX_LENGTH = 1 * 1024 * 1024

    def initialize(schema)
        @columns_map = {}
        
        @shard_id = nil
        @attributes = {}
        
        @schema = schema
    end
    
    def set(name, value)
        @columns_map[name] = value
    end
    
    def set_shard_id(shard_id)
        if shard_id.is_a?String
            @shard_id = shard_id
        else
            raise "shard_id must be String type!"
        end
    end
    
    def add_attribute(name, value)
        @attributes[name] = value
    end

    def get_columns_map
        return @columns_map
    end

    def get_schema
        return @schema
    end


    def setBigInt(name, value)
        if value == nil
            set(name, value)
        elsif value.is_a?Integer
            set(name, value)
        elsif value.is_a?String and value.to_i.to_s == value
            set(name, value.to_i)
        else
            raise "value show be Integer, name:" + name.to_s + " value:" + value.to_s
        end
    end

    def setDouble(name, value)
        if value == nil
            set(name, value)
        elsif value.is_a?Float
            set(name, value)
        elsif value.is_a?String
            begin
                set(name, Float(value))
            rescue
                raise "value show be Float, name:" + name.to_s + " value:" + value.to_s
            end
        else
            raise "value show be Float, name:" + name.to_s + " value:" + value.to_s
        end
    end

    def setBoolean(name, value)
        if value == nil
            set(name, value)
        elsif value.is_a?String
            if value == "true"
                set(name, true)
            elsif value == "false"
                set(name, false)
            else
                raise "value must be true or false, name:" + name.to_s + " value:" + value.to_s
            end
        elsif value != false and value != true
            raise "value must be bool or string[true,false], name:" + name.to_s + " value:" + value.to_s
        end
        set(name, value)
    end

    def setTimeStamp(name, value)
        if value == nil
            set(name, value)
        elsif value.is_a?Integer
            set(name, value)
        elsif value.is_a?String and value.to_i.to_s == value
            set(name, value.to_i)
        else
            raise "value should be Integer, name:" + name.to_s + " value:" + value.to_s
        end
    end

    def setString(name, value)
        if value == nil
            set(name, value)
        elsif value.is_a?String and value.length < $STRING_MAX_LENGTH
            if @schema.get_encoding == nil
                set(name, value)
            else
                # puts "encoding:" + @schema.get_encoding.to_s
                value.force_encoding(@schema.get_encoding)
                set(name, value)
                # puts value
            end
        else
            raise "value show be String and len < " + $STRING_MAX_LENGTH.to_s + ", name:" + name.to_s + " value:" + value.to_s
        end
    end
    
    def get_stored_column_values
        data = []
        fields = @schema.get_fields
        for i in 0...fields.size
            field = fields[i]
            name = field.get_name
            if @columns_map[name] == nil
                data.push(@columns_map[name])
            elsif
                data.push(@columns_map[name].to_s)
            end
        end
        return data
    end
    
    def to_json(*a)
        {
            "Data" => get_stored_column_values,
            "ShardId" => @shard_id,
            "Attributes" => @attributes
        }.to_json(*a)
    end
    
end
