require "json"

class RecordField

    def initialize(name, type)
        @name = name
        @type = type
    end
    
    def get_name()
        return @name
    end
    
    def get_type()
        return @type
    end
    
    def to_json(*a)
        field_map = {}
        field_map["name"] = @name
        field_map["type"] = @type
        return field_map.to_json(*a)
    end
    
end

class RecordSchema
    def initialize()
        @fields = []

        @encoding = nil

        @fields_map = {}
    end

    def setEncoding(encoding)
        if ["US-ASCII", "ASCII-8BIT", "UTF-8", "ISO-8859-1", "Shift_JIS", "EUC-JP", "Windows-31J", "BINARY", "CP932", "eucJP"].include?(encoding)
            @encoding = encoding
        else
            raise "Unsupported encoding type [" + encoding.to_s + "]."
        end
    end

    def get_encoding
        return @encoding
    end
    
    def add_field(field)
        @fields.push(field)
        @fields_map[field.get_name] = field
    end

    def get_field(name)
        # @fields.each do |field|
        #     if field.get_name == name
        #         return field
        #     end
        # end
        # return nil
        return @fields_map[name]
    end
    
    def get_fields()
        return @fields
    end
    
    def to_json(*a)
        tuple = {}
        tuple["fields"] = @fields
        tuple.to_json(*a)
    end
end

